import {select,
        csv, 
        scaleLinear,
        max, 
        scaleBand,
        scalePoint,
       	axisLeft,
       axisBottom,
       format,
       extent} from 'd3';

const svg = d3.select('svg');
// svg.style('background-color', 'red');

	// d.mpg=+d.mpg
	// d.displacement=+d.displacement
	// d.cylinders=+d.cylinders
	// d.weight=+d.weight
	// d.horsepower=+d.horsepower
	// d.acceleration=+d.acceleration
	// d.year=+d.year



const height = parseFloat(svg.attr('height'));

const width = parseFloat(svg.attr('width'));

const render= data =>{
  const xAxisLabel= 'MPG'
  const yAxisLabel= 'horsepower'
  const xValue= d => d.mpg;
  const yValue= d =>d.horsepower;
  const circleradius= 10; 
  const margin= {top:60 , right:20, bottom:30, left:200};
  const innerWidth= width-margin.left-margin.right
  const innerHeight= height-margin.top-margin.bottom
  console.log(yValue) 
  
  const xscale = scaleLinear()
  		.domain(extent(data, xValue))
  		.range([0, innerWidth])
  		.nice();
  
  
  
  const yscale= scaleLinear()
  	.domain(extent(data, yValue))
  	.range([0,innerHeight])
  	// .padding(0.5)
  const yAxis = axisLeft(yscale).tickSize(-innerWidth).tickPadding(10)  
  const xAxis = axisBottom(xscale)
            
  const g= svg.append('g')
  	.attr('transform', `translate(${margin.left},${margin.right})`);
    
  const xAxisTickFormat = number => format('.3s')(number).replace('G', 'B')
  // yAxis(g.append('g'));
 	const yAxisG= g.append('g').call(yAxis);
  yAxisG
  	.selectAll('.domain')
  		.remove();
  const xAxisG = g.append('g')
  .call(xAxis.tickFormat(xAxisTickFormat)
  .tickSize(-innerHeight) 
  .tickPadding(10)
                                   )
  .attr('transform', `translate(0,${innerHeight})`);
  	xAxisG.selectAll('.domain')
  		.remove();
  xAxisG.append('text')
  	.attr('class', 'axis-label')
  	.attr('y',60)
  	.attr('x', innerWidth/2)
  	.attr('fill','black')
  	.text(xAxisLabel)
  
  
   yAxisG.append('text')
  	.attr('transform', `rotate(-90)`)
  	.attr('text-anchor','middle' )
  	.attr('class', 'axis-label')
  	.attr('y',-90)
  	.attr('x',-innerHeight/2)
  	.attr('fill','black')
  	.text(yAxisLabel)
  
  
  g.append('text')
  	.attr('class', 'title')
  	.attr('y', -5)
  	.text('Top 10 most Populous Countries')
  
  console.log(yscale.domain())          
	g.selectAll('circle').data(data)
	.enter().append('circle')
	.attr('cy', d => yscale(yValue(d)))
	.attr('cx',d => xscale(xValue(d)))
	.attr('r',circleradius)
};

csv('https://vizhub.com/curran/datasets/auto-mpg.csv')
  .then(data =>{
  data.forEach(d =>{
  d.mpg=+d.mpg
  d.displacement=+d.displacement
  d.cylinders=+d.cylinders
  d.weight=+d.weight
  d.horsepower=+d.horsepower
  d.acceleration=+d.acceleration
  d.year=+d.year
  });
        
  console.log(data)      
  render(data);
});






